#! /usr/bin/python
# coding: Utf-8

import os, sys, threading, signal
import gtk, dbus.mainloop.glib
import Xlib.X, Xlib.display

thread = None
lockuuid = None
lockpath = None

# Repérage d'une précédente instance…
f = os.popen("ps -ef | grep "+sys.argv[0]+" | grep -v grep | tr -s ' '")
lines = f.readlines()
f.close()
for line in lines:
	line = line.replace("\n", "").split(" ")
	if (line[1] == str(os.getpid())): continue
	if ((line[7] == "python" or line[7] == "/usr/bin/python")
	 and line[8] == sys.argv[0]): # Ah, ça tourne déjà.
		os.system("kill -USR1 " + line[1])
		quit() # Voilà, c'est tout.

# Signal reçu.
def __signalgot(*args):
	#window.present()
	if (thread != None):
		thread._Thread__stop()
	gtk.main_quit()

# Branchement du signal pour double-lancement…
signal.signal(signal.SIGUSR1, __signalgot)

# Lecture de l'icône demandée…
pixbuf = gtk.icon_theme_get_default().load_icon(
	"drive-removable-media", 48, gtk.ICON_LOOKUP_USE_BUILTIN)

# Récupération de l'écran…
display = Xlib.display.Display()
root = display.screen().root

# Quitte sur la touche échap.
def __check_key(widget, event):
	if (event.keyval == 65307):
		gtk.main_quit()

# Utilise le périph pour le blocage.
def __dev_lock(view, path, data=None):
	global lockuuid, lockpath
	lockpath = devstore[path][2]
	lockuuid = devstore[path][3]

# Réagit au branchement.
def __dev_added(path):
	device = dbus.Interface(bus.get_object(
		"org.freedesktop.UDisks", path),
		"org.freedesktop.UDisks.Device")
	props = dbus.Interface(device, dbus.PROPERTIES_IFACE)
	uuid = props.Get("org.freedesktop.UDisks.Device", "IdUuid")
	if (uuid == lockuuid):
		os.system("sh -c 'sleep 1; xset dpms force on' &")
		thread._Thread__stop()
		gtk.main_quit() # Fini.
	elif (lockuuid == None):
		label = props.Get("org.freedesktop.UDisks.Device", "IdLabel")
		if (label == ""): return # On laisse tomber.
		parent = path # Voyons si ça se démonte.
		while (parent[-1].isdigit()):
			parent = parent[:-1]
		device = dbus.Interface(bus.get_object(
			"org.freedesktop.UDisks", parent),
			"org.freedesktop.UDisks.Device")
		props = dbus.Interface(device, dbus.PROPERTIES_IFACE)
		if (props.Get("org.freedesktop.UDisks.Device",
			"DeviceIsRemovable") != 1): return # Donc non.
		devstore.append([label, pixbuf, path, uuid])
		width = min(len(devstore), 3) * 140
		window.set_geometry_hints(window, width,110, width,110)
		window.remove(window.get_child())
		window.add(scroll)

# Réagit au débranchement.
def __dev_removed(path):
	if (lockpath == None):
		for i in range(0, len(devstore), 1):
			if (devstore[i][2] == path):
				i = devstore.get_iter(i)
				devstore.remove(i)
				if (len(devstore) == 0):
					window.remove(scroll)
					window.add(falseview)
				else: # Réglage de la taille…
					width = min(len(devstore), 3) * 140
					window.set_geometry_hints(window,
						width,110, width,110)
				return # Voilà, c'est bon.
	elif (path == lockpath):
		global thread
		thread = threading.Thread(None, __offscreen)
		root.grab_pointer(True, Xlib.X.ButtonPressMask
			| Xlib.X.ButtonReleaseMask | Xlib.X.PointerMotionMask,
			Xlib.X.GrabModeAsync, Xlib.X.GrabModeAsync,
			0, 0, Xlib.X.CurrentTime)
		root.grab_keyboard(True, Xlib.X.GrabModeAsync,
			Xlib.X.GrabModeAsync, Xlib.X.CurrentTime)
		thread.start()

# Eteind l'écran.
def __offscreen():
	while True: # Allons-y…
		os.system("xset dpms force off")
		display.next_event()

# Connexion à DBus et branchements.
dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
bus = dbus.SystemBus() # Et on récupère l'interface requise…
udisk = bus.get_object("org.freedesktop.UDisks", "/org/freedesktop/UDisks")
interface = dbus.Interface(udisk, "org.freedesktop.UDisks")
interface.connect_to_signal("DeviceRemoved", __dev_removed)
interface.connect_to_signal("DeviceAdded", __dev_added)

# Création de la fenêtre.
window = gtk.Window()
window.set_title("Verrouillage USB")
window.set_icon(gtk.icon_theme_get_default().load_icon(
	"lock", 48, gtk.ICON_LOOKUP_USE_BUILTIN))
window.connect("key-press-event", __check_key)
window.connect("destroy", quit)
window.set_resizable(False)
falseview = gtk.VBox(False, 2)
falseview.set_border_width(10)
falseview.add(gtk.image_new_from_pixbuf(pixbuf))
label = gtk.Label(" Aucune clef ")
label.set_markup("<i>"+label.get_text()+"</i>")
falseview.add(label)
falseview.set_sensitive(False)
window.add(falseview)
window.show_all()

# Création de la liste d'icônes.
devstore = gtk.ListStore(str, gtk.gdk.Pixbuf, str, str)
icview = gtk.IconView(devstore)
icview.set_pixbuf_column(1)
icview.set_text_column(0)
icview.set_item_width(120)
icview.connect("item-activated", __dev_lock)
scroll = gtk.ScrolledWindow()
scroll.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
scroll.add(icview)
scroll.show_all()

# Récupération des disques déjà présents.
for path in interface.EnumerateDevices():
	__dev_added(path)

# Démarrage.
gtk.threads_init()
gtk.main()
